
var ref = require("@craco/craco");
var getLoader = ref.getLoader;
var loaderByName = ref.loaderByName;
var getArray = function (source) {
    if (!source) {
        return [];
    }
    return Array.isArray(source) ? source : [source];
};
var include = function (ts_loader) {
    var includes = [], len = arguments.length - 1;
    while ( len-- > 0 ) includes[ len ] = arguments[ len + 1 ];

    var include_config = getArray(ts_loader.include);
    includes = includes.reduce(function (accumulator, include) {
        if (Array.isArray(include)) {
            return accumulator.concat(include);
        }
        accumulator.push(include);
        return accumulator;
    }, include_config);
    ts_loader.include = includes;
};
var exclude = function (ts_loader) {
    var excludes = [], len = arguments.length - 1;
    while ( len-- > 0 ) excludes[ len ] = arguments[ len + 1 ];

    var exclude_config = getArray(ts_loader.exclude);
    excludes = excludes.reduce(function (accumulator, exclude) {
        if (Array.isArray(exclude)) {
            return accumulator.concat(exclude);
        }
        accumulator.push(exclude);
        return accumulator;
    }, exclude_config);
    ts_loader.exclude = excludes;
};
var overrideWebpackConfig = function (ref) {
    var webpackConfig = ref.webpackConfig;
    var ref_pluginOptions = ref.pluginOptions;
    var includes = ref_pluginOptions.includes; if ( includes === void 0 ) includes = [];
    var excludes = ref_pluginOptions.excludes; if ( excludes === void 0 ) excludes = [];

    var ref$1 = getLoader(webpackConfig, loaderByName("ts-loader"));
    var isFound = ref$1.isFound;
    var match = ref$1.match;
    if (isFound) {
        includes.forEach(function (path) { return include(match.loader, path); });
        excludes.forEach(function (path) { return exclude(match.loader, path); });
    }
    return webpackConfig;
};

exports.overrideWebpackConfig = overrideWebpackConfig;
//# sourceMappingURL=index.js.map
